/*
 * ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GTDInbox.
 *
 * The Initial Developer of the Original Code is
 * Andy Mitchell (andy@gtdinbox.com)
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */


/**
 * Minimal definition for a plugin (e.g. gtdMainPagePlugin)
 *
 * @class ?
 */
var glPluginBase = glBase.extend({
    // Properties {
    
    /**
     * glGmail object
     * @property {glGmail} ?
     */
    gmail: null,
    
    
    //}

    /**
     * The constructor.
     * @constructor ?
     */
    constructor: function() {
    },

    /**
     * Load components required for Gmail integration; and kick-start processes
     * @function {} ?
     * @param {glGmail} gmail - The glGmail object for the page
     */
    loadForGmail: function(gmail){
	
	this.gmail = gmail;
    },
    
    /**
     * Returns a list of the required glGmail components
     * @function {Array} ?
     * @return The required glGmail components
     */
    getRequiredComponents: function() {
        return [];
    },
    
    /**
     * Get the glpPreferencesBase derived object that represents the preferences for this plugin
     * Always fires glPluginBase.LOADED_PREFERENCES, even if synchronous
     * @function {glpPreferencesBase} ?
     */
    requestPreferences: function(){
        
    },

    /**
     * Called on page unload, it cleans up everything
     * @function ?
     */
    unload: function() {
	this.gmail = null;
    },


    
    
    //}
},{
    
    // Static Properties {
    /**
     * The default properties object
     * @property {static Object} ?
     */    
    DEFAULT_PREFS: null,
    
    /**
     * Fired after getPreferences call; when glpPluginsBase-derived object is ready (could be an asynchronous load)
     * @event
     */
    LOADED_PREFERENCES: 'loaded_preferences',
    
    // }
});
glPluginBase.implement(glEventDispatcher); // Add event dispatching support